var datatableDataset = SuperWidget.extend({
	instanceId: null,
	mode: null,
	colleagueTable: null,
	dataInit: null,
	limit: null,

    init: function () {
    	datatableDataset.instanceId = this.instanceId;
    	if(this.mode != null && this.mode == 'edit'){
			return;
		}
    	datatableDataset.limit = 3; //You can change the limit of items per page here
    	datatableDataset.createColleagueDatatable();
    },

    createColleagueDatatable: function(){
    	datatableDataset.colleagueTable = FLUIGC.datatable('#datatableRestColleague', {
    	    dataRequest: {
    	        url: WCMAPI.getServerURL() + '/dataset/api/v2/dataset-handle/search',
    	        options: {
    	            contentType:'application/json',
    	            dataType: 'json',
    	            crossDomain: true,
    	            cache: false,
    	            data: "datasetId=colleague" //You can change the requested dataset here
    	        },
    	        root: 'content',
    	        limit: datatableDataset.limit,
    	        offset: 0,
    	        patternKey: 'text',
    	        limitkey: 'limit',
    	        offsetKey: 'offset',
    	        formatData: function(data) {
    	            return data.values;
    	        }
    	    },
    	    renderContent: '.template_colleague', //The template is on the view.ftl file and it sets what fields is going to be show
    	    header: [
    	        {
    	            'title': 'Login',
    	            'dataorder': 'login',
    	            'standard': true,
    	            'size': 'col-md-4',
    	        },
    	        {
    	            'title': 'Colleague Name',
    	            'dataorder': 'colleagueName',
    	            'size': 'col-md-5',
    	        },
    	        {
    	            'title': 'Mail',
    	            'dataorder': 'mail',
    	            'size': 'col-md-5',
    	        }
    	    ],
    	    multiSelect: false,
    	    classSelected: 'danger',
    	    search: {
    	        enabled: true,
    	        onSearch: function(response) {
    	        	if (!response) {
    	        		datatableDataset.colleagueTable.reload(dataInit);
                    }
    	        	var url = WCMAPI.getServerURL();
    	            url += "/dataset/api/v2/dataset-handle/search?datasetId=colleague&limit="+datatableDataset.limit;
    	            if(response != null && response != ""){
    	            	url += datatableDataset.createSearchConstraint("colleagueName", response);
    	            }
    	            $.get(url, function( data ) {
    	            	if(data.values.length > 0){
    	    				datatableDataset.colleagueTable.reload(data.values);
    	    			}else{
    	    				FLUIGC.toast({
                                title: 'Searching: ',
                                message: 'No results',
                                type: 'warning'
                            });
    	    			}
	            	});
    	        },
    	        onlyEnterkey: true,
    	        searchAreaStyle: 'col-md-3'
    	    },
    	    scroll: {
    	        enabled: false
    	    },
    	    actions: {
    	        enabled: false
    	    },
    	    navButtons: {
    	        enabled: true,
    	        forwardstyle: 'btn-warning',
    	        backwardstyle: 'btn-warning',
    	    },
    	    emptyMessage: '<div class="text-center">No data to display.</div>',
    	    tableStyle: 'table-striped',
    	    draggable: {
    	        enabled: false
    	    }
    	}, function(err, data) {
    		if(data) {
                dataInit = data;
            }
            else if (err) {
                FLUIGC.toast({
                    message: err,
                    type: 'danger'
                });
            }
    	});
    },
    
    //This method creates the constraints to do a like search in the constraintField with the constraintSearch 
    createSearchConstraint: function(constraintField, constraintSearch) {
    	return "&constraintsField="+constraintField
    			+"&constraintsInitialValue="+constraintSearch+"%25"
    			+"&constraintsType=SHOULD"
    			+"&constraintsLikeSearch=true"
    			+"&constraintsField="+constraintField
    			+"&constraintsInitialValue=%25"+constraintSearch+"%25"
    			+"&constraintsType=SHOULD"
    			+"&constraintsLikeSearch=true"
    			+"&constraintsField="+constraintField
    			+"&constraintsInitialValue=%25"+constraintSearch
    			+"&constraintsType=SHOULD"
    			+"&constraintsLikeSearch=true";
    }
    
});